#pragma once
#include <string>
namespace graft_cv{
typedef unsigned char byte;
typedef struct 
{
    int channel;
    int width;
    int height;
    byte *data;
}ImgInfo;

typedef struct{
	// Կ (2)
	bool image_show;//true--ʾемͼƬҪ˹سִܼ; false--ͼƬʾ
	bool image_return;//true--ؽpositoninfoӷصͼƬ; false--ͼƬ

	//image storage parameters(3)
	bool image_save;//Ƿ񱣴ͼ
	std::string image_depository;//ͼĿ¼
	int image_backup_days;//ͼɾ
	
	// rootstock grab based points cloud
	double rs_grab_xmin;
	double rs_grab_xmax;
	double rs_grab_ymin;
	double rs_grab_ymax;
	double rs_grab_zmin;
	double rs_grab_zmax;
	double rs_grab_zcent;


	double rs_grab_stem_diameter;	
	double rs_grab_seedling_dist;
	int rs_grab_stem_min_pts;
	int rs_grab_seedling_min_pts;
	double rs_grab_ror_ratio;
	double rs_grab_fork_ratio;
	double rs_grab_offset;	
	double rs_grab_fork_yup; //ڸ߶
	double rs_grab_fork_ybt; //ڸ߶ޣ ڷΧڣ
	double rs_grab_offset_cut; // ybtyupмƫƣλü㾥
	double rs_grab_fork_height; //ڸ߶ȣСֵףСڴֵʶ
	int rs_grab_holes_number; //Ѩ
	double rs_grab_valid_stem_ratio; //Ұ߶ϵռֵСڴֵʶɾ
	double rs_grab_valid_occlusion_ratio;//ڵҰ߶ϵռֵСڴֵʶڵ
	double rs_grab_valid_overall_ratio;//+ҶҰ߶ϵռֵСڴֵʶ

	// scion grab based points cloud
	double sc_grab_xmin;//Ѩ
	double sc_grab_xmax;//Ѩ
	double sc_grab_ymin;
	double sc_grab_ymax;
	double sc_grab_zmin;
	double sc_grab_zmax;
	double sc_grab_zcent;

	double sc_grab_stem_diameter;	
	double sc_grab_seedling_dist;
	int sc_grab_stem_min_pts;
	int sc_grab_seedling_min_pts;
	double sc_grab_ror_ratio;
	double sc_grab_fork_ratio;
	double sc_grab_offset_nofork;	//޾ڵƫ	
	double sc_grab_offset_up;		//yupϵƫ
	double sc_grab_offset_bt;		//ybtµƫ	
	double sc_grab_offset_normal;	//ybtyupµƫ	


	double sc_grab_fork_yup; //ڸ߶
	double sc_grab_fork_ybt; //ڸ߶ޣ ڷΧڣ
	double sc_grab_offset_cut; // ybtyupмƫƣλü㾥
	double sc_grab_fork_height; //ڸ߶ȣСֵףСڴֵʶ
	int sc_grab_holes_number; //Ѩ
	double sc_grab_valid_stem_ratio;
	double sc_grab_valid_occlusion_ratio;
	double sc_grab_valid_overall_ratio;//+ҶҰ߶ϵռֵСڴֵʶ
} ConfigParam;

typedef struct 
{
	//漰λþΪʵλã
	double rs_grab_x;//ľץȡλx
	double rs_grab_y;//ľץȡλy
	double rs_grab_z;//ľץȡλz
	double rs_fork_y1;//ľ羥1y꣬, -1000ʾ
	double rs_fork_y2;//ľ羥2y꣬, -1000ʾ
	double rs_fork_y3;//ľ羥2y꣬, -1000ʾ
	double rs_width;		//Ŀȣֱ
	double rs_tortuosity;	//ȣ뾥룬
	double rs_count;		//ǰһŹж


	double sc_grab_x;//ץȡλx
	double sc_grab_y;//ץȡλy
	double sc_grab_z;//ץȡλz	
	double sc_width;		//Ŀȣֱ
	double sc_tortuosity;	//ȣ뾥룬
	double sc_count;		//ǰһŹж	
	ImgInfo* pp_images[5];//οͼƬֻǰûеĻᱻ
	
}PositionInfo;


};